/*******************************************************************************
 * Copyright (c) 2004, 2005 IBM Corporation.
 * All rights reserved. 
 *******************************************************************************/
package com.ibm.samplesgallery.servlets;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.ibm.samplegallery.internal.GalleryConstants;
import com.ibm.samplegallery.internal.LayoutData;
import com.ibm.samplegallery.internal.WebappPreferences;

/**
 * Process request displaying the tabs - treew view tab and bookmark tab.
 */
public class GalleryTabs extends HttpServlet implements GalleryConstants {
	/* (non-Javadoc)
	 * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	protected void doGet(HttpServletRequest arg0, HttpServletResponse arg1)
		throws ServletException, IOException {
		this.processRequest(arg0, arg1);
	}
	
	/* (non-Javadoc)
	 * @see javax.servlet.http.HttpServlet#doPost(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	protected void doPost(HttpServletRequest arg0, HttpServletResponse arg1)
		throws ServletException, IOException {
		this.processRequest(arg0, arg1);
	}
	
	private void processRequest(HttpServletRequest req, HttpServletResponse resp) throws IOException {
		LayoutData data = new LayoutData(req, resp);
		WebappPreferences prefs = data.getPrefs();

		resp.setContentType("text/html;charset=UTF-8"); //$NON-NLS-1$
		StringBuffer html = new StringBuffer();
		html.append("<html class=\"tabs\">\n"); //$NON-NLS-1$
		html.append("<head>\n"); //$NON-NLS-1$
		
		html.append("<style type=\"text/css\">\n"); //$NON-NLS-1$
		html.append("BODY {\n"); //$NON-NLS-1$
		html.append("margin:0px;\n"); //$NON-NLS-1$
		html.append("padding:0px;\n"); //$NON-NLS-1$
		html.append("background:" + prefs.getToolbarBackground() + ";\n"); //$NON-NLS-1$ //$NON-NLS-2$
		html.append("height:100%;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$

		/* tabs at the bottom */
		html.append(".tab {\n"); //$NON-NLS-1$
		html.append("font-size:5px;\n"); //$NON-NLS-1$
		html.append("margin:0px;\n"); //$NON-NLS-1$
		html.append("padding:0px;\n"); //$NON-NLS-1$
		html.append("border-top:1px solid ThreeDShadow;\n"); //$NON-NLS-1$
		html.append("border-bottom:1px solid ThreeDShadow;\n"); //$NON-NLS-1$

		html.append("cursor:default;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$

		html.append(".pressed {\n"); //$NON-NLS-1$
		html.append("font-size:5px;\n"); //$NON-NLS-1$
		html.append("margin:0px;\n"); //$NON-NLS-1$
		html.append("padding:0px;\n"); //$NON-NLS-1$
		html.append("cursor:default;\n"); //$NON-NLS-1$
		html.append("background-color:" + prefs.getViewBackground() +";\n"); //$NON-NLS-1$ //$NON-NLS-2$
		html.append("border-top:1px solid " + prefs.getViewBackground() +";\n"); //$NON-NLS-1$ //$NON-NLS-2$
		html.append("border-bottom:1px solid ThreeDShadow;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$

		html.append(".separator {\n"); //$NON-NLS-1$
		html.append("height:100%;\n"); //$NON-NLS-1$
		html.append("background-color:ThreeDShadow;\n"); //$NON-NLS-1$
		html.append("border-bottom:1px solid " + prefs.getToolbarBackground() + ";\n"); //$NON-NLS-1$ //$NON-NLS-2$
		html.append("}\n"); //$NON-NLS-1$
		
		html.append(".separator_pressed {\n"); //$NON-NLS-1$
		html.append("height:100%;\n"); //$NON-NLS-1$
		html.append("background-color:ThreeDShadow;\n"); //$NON-NLS-1$
		html.append("border-top:1px solid " + prefs.getViewBackground() + ";\n"); //$NON-NLS-1$ //$NON-NLS-2$
		html.append("border-bottom:1px solid " + prefs.getToolbarBackground() +";\n"); //$NON-NLS-1$ //$NON-NLS-2$
		html.append("}\n"); //$NON-NLS-1$

		html.append("A {\n"); //$NON-NLS-1$
		html.append("text-decoration:none;\n"); //$NON-NLS-1$
		html.append("vertical-align:middle;\n"); //$NON-NLS-1$
		html.append("height:16px;\n"); //$NON-NLS-1$
		html.append("width:16px;\n"); //$NON-NLS-1$
		html.append("writing-mode:tb-rl;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$

		html.append("IMG {\n"); //$NON-NLS-1$
		html.append("border:0px;\n"); //$NON-NLS-1$
		html.append("margin:0px;\n"); //$NON-NLS-1$
		html.append("padding:0px;\n"); //$NON-NLS-1$
		html.append("height:16px;\n"); //$NON-NLS-1$
		html.append("width:16px;\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("</style>\n"); //$NON-NLS-1$

		html.append("<script language=\"JavaScript\">\n"); //$NON-NLS-1$

		html.append("var lastTab = \"\";\n"); //$NON-NLS-1$
		html.append("function showTab(tab)\n"); //$NON-NLS-1$
		html.append("{\n"); //$NON-NLS-1$
		html.append("if (tab == lastTab)\n"); //$NON-NLS-1$
		html.append("return;\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append("lastTab = tab;\n"); //$NON-NLS-1$
		html.append("\n"); //$NON-NLS-1$
		html.append("// show the appropriate pressed tab\n"); //$NON-NLS-1$
		html.append("var buttons = document.body.getElementsByTagName(\"TD\");\n"); //$NON-NLS-1$
		html.append("for (var i=0; i<buttons.length; i++)\n"); //$NON-NLS-1$
		html.append("{\n"); //$NON-NLS-1$
		html.append("if (buttons[i].id == tab) {\n"); //$NON-NLS-1$
		html.append("buttons[i].className = \"pressed\";\n"); //$NON-NLS-1$
		html.append("if (i > 0)\n"); //$NON-NLS-1$
		html.append("buttons[i-1].className = \"separator_pressed\";\n"); //$NON-NLS-1$
		html.append("if (i<buttons.length-1)\n"); //$NON-NLS-1$
		html.append("buttons[i+1].className = \"separator_pressed\";\n"); //$NON-NLS-1$
		html.append("} else if (buttons[i].className == \"pressed\") {\n"); //$NON-NLS-1$
		html.append("buttons[i].className = \"tab\";\n"); //$NON-NLS-1$
		html.append("if (i > 0)\n"); //$NON-NLS-1$
		html.append("if (i > 1 && buttons[i-2].id == tab)\n"); //$NON-NLS-1$
		html.append("buttons[i-1].className = \"separator_pressed\";\n"); //$NON-NLS-1$
		html.append("else\n"); //$NON-NLS-1$
		html.append("buttons[i-1].className = \"separator\";\n"); //$NON-NLS-1$
		html.append("if (i<buttons.length-1)\n"); //$NON-NLS-1$
		html.append("if (i<buttons.length-2 && buttons[i+2].id == tab)\n"); //$NON-NLS-1$
		html.append("buttons[i+1].className = \"separator_pressed\";\n"); //$NON-NLS-1$
		html.append("else\n"); //$NON-NLS-1$
		html.append("buttons[i+1].className = \"separator\";\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$
		html.append("}\n"); //$NON-NLS-1$

		html.append("</script>\n"); //$NON-NLS-1$
		
		html.append("</head>\n"); //$NON-NLS-1$
		html.append("<body class=\"tabs\">\n"); //$NON-NLS-1$
		html.append("<table cellspacing=\"0\" cellpadding=\"0\" border=\"0\" width=\"100%\" height=\"100%\" valign=\"middle\">"); //$NON-NLS-1$
		html.append("<tr>"); //$NON-NLS-1$
		html.append("<td  title=\"" + "Contents" + "\"");  //$NON-NLS-1$
		html.append(" align=\"center\"");   //$NON-NLS-1$
		html.append(" valign=\"middle\""); //$NON-NLS-1$
		html.append(" class=\"tab\"");  //$NON-NLS-1$
		html.append(" id=\"toc\"");  //$NON-NLS-1$
		html.append(" onclick=\"parent.showView('toc')\"");  //$NON-NLS-1$
		html.append(" onmouseover=\"window.status='" + "Contents" + "';return true;\""); 
		html.append(" onmouseout=\"window.status='';\">"); //$NON-NLS-1$
		html.append("<a href='javascript:parent.showView(\"toc\");'");  //$NON-NLS-1$
		html.append(" onclick='this.blur();return false;'");  //$NON-NLS-1$
		html.append(" onmouseover=\"window.status='" + "Contents" + "';return true;\""); 
		html.append(" onmouseout=\"window.status='';\""); //$NON-NLS-1$
		html.append("id=\"linktoc\">"); //$NON-NLS-1$
		html.append("<img alt=\"" + "Contents" + "\"");
		html.append(" title=\"" + "Contents" + "\""); 
		html.append(" src=\"images/e_contents_view.gif\""); //$NON-NLS-1$
		html.append(" id=\"imgtoc\""); //$NON-NLS-1$
		html.append(" height=\"16\">"); //$NON-NLS-1$
		html.append("</a>"); //$NON-NLS-1$
		html.append("</td>"); //$NON-NLS-1$
		html.append("<td width=\"1px\" class=\"separator\"></td>"); //$NON-NLS-1$
		html.append("<td  title=\"" + "Bookmarks" + "\"");  //$NON-NLS-1$
		html.append(" align=\"center\"");   //$NON-NLS-1$
		html.append(" valign=\"middle\""); //$NON-NLS-1$
		html.append(" class=\"tab\"");  //$NON-NLS-1$
		html.append(" id=\"bookmarks\"");  //$NON-NLS-1$
		html.append(" onclick=\"parent.showView('bookmarks')\"");  //$NON-NLS-1$
		html.append(" onmouseover=\"window.status='" + "Bookmarks" + "';return true;\""); 
		html.append(" onmouseout=\"window.status='';\">"); //$NON-NLS-1$
		html.append("<a href='javascript:parent.showView(\"bookmarks\");'"); //$NON-NLS-1$
		html.append(" onclick='this.blur();return false;'");  //$NON-NLS-1$
		html.append(" onmouseover=\"window.status='" + "Bookmarks" + "';return true;\""); 
		html.append(" onmouseout=\"window.status='';\""); //$NON-NLS-1$
		html.append(" id=\"linkbookmarks\">"); //$NON-NLS-1$
		html.append("<img alt=\"" + "Bookmarks" + "\"");
		html.append(" title=\"" + "Bookmarks" + "\""); 
		html.append(" src=\"images/e_bookmarks_view.gif\""); //$NON-NLS-1$
		html.append(" id=\"imgbookmarks\""); //$NON-NLS-1$
		html.append(" height=\"16\">"); //$NON-NLS-1$
		html.append("</a>"); //$NON-NLS-1$
		html.append("</td>"); //$NON-NLS-1$
		html.append("</tr>"); //$NON-NLS-1$
		html.append("</table>"); //$NON-NLS-1$
		html.append("</html>\n"); //$NON-NLS-1$
		String htmlString = html.toString();
		resp.getWriter().println(htmlString);
	}
}
